# [ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ]
#   Name:	  Sitebot Hub
#   Version:	  3.4
#   Last Updated: 2004-?
#   Author:	  Original by DaRKHeaRT | Some good stuff from GOD-EMPEROR |
#		  Remade by F|owman
#   Contact:	  F|owman @ #thedebug on Efnet
#   Notes:	  Bad configuration might lead to errors, so be WARNED.
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This script is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
#	GNU General Public License for more details.
# [ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ]

#-- Sitebot Main --------------------------------------------------------------------#
proc sitebot:main {} {
  uplevel #0 {
    sitebot:killoldtimers
    sitebot:init
    putlog "+--\[ SITEBOT v3.4 \]----------------------------------------------- -- --- - - -"
    sitebot:loadconf
    sitebot:sets api
    sitebot:loadapi
    sitebot:loadskin
    sitebot:functions
    sitebot:hub
    sitebot:killextratimers
    putlog "| $sitebot(site).. BOT UP.. Fingers Crossed.. Loading Sections"
    sitebot:updater
    sitebot:addonsearch
    sitebot:addonmanager
    sitebot:checkscripts
    if { [info exists enabled(announce)] } { if $enabled(announce) { putlog "| SITEBOT: Announce addon located.... Starting tail" ; sitebot:announce } }
    putlog "| $sitebot(site) $sitevars(version)"
    putlog "`------------------------------------------- -- \[ [b]Sitebot[b] \] - - "
  }
}

proc sitebot:killoldtimers {} {
  foreach this [timers] {
    if { ([string compare [lindex $this 1] "leafchk"] == 0) || ([string compare [lindex $this 1] "sitebot:autochkupdate"] == 0) } {
      killtimer [lindex $this 2]
    }
  }
}

proc sitebot:killextratimers {} { global addonExtraTimer
  foreach this [utimers] {
    foreach extra $addonExtraTimer {
      if { ([string compare [lindex $this 1] $extra] == 0) }  {
        killutimer [lindex $this 2]
      }
    }
  }
}

proc sitebot:init {} {
  uplevel #0 {
    if {![info exists sitevars(api)]} { set sitevars(api) sitebot.api }
    if {![info exists sitevars(config)]} { set sitevars(config) sitebot.cfg }
    if {![info exists sitevars(skin)]} { set sitevars(skin) sitebot-default.skin }
    set sitevars(currentConfigVersion) 3.4
    set sitevars(currentApiVersion) 3.4
    set sitevars(build) 41
    set sitevars(version) "SiteBot v3.4 Glftpd Edition"
    set sitevars(currentVersion) [join $sitevars(currentConfigVersion).$sitevars(build)]
    if {[set tcl_version] < 8.3} {die "SITEBOT: Incompatible TCL version found (8.3 or later required)"}
    package require http 2.3
    set urlList [list http://flowman.ath.cx/sitebot34/ http://flowman.24hour-cams.com/sitebot33/]

    if {[info exists f]} {
      foreach type $f { 
        if {[string match "*sitebot.tcl*" $type]} { set sitebotLocation [string map "/sitebot.tcl {}" $type] }
      }
    } else {
      set sitebotLocation [split [string map "./ {} /sitebot.tcl {}" [exec find -name sitebot.tcl]] "\n"]
      if {[llength $sitebotLocation] > 1} {
        putlog "SITEBOT: Error.. You got more then one sitebot.tcl in your eggdrop/scripts dir."; return 0
      }
    }
    if {![info exists sitebotLocation]} { putlog "SITEBOT: Error.. Didnt find myself. Dont rename the file if u have done it."; return 0 }
    if {![info exists sitebot(sitebotDir)]} { set sitebot(sitebotDir) $sitebotLocation }

    if {![file exists sitebot(sitebotDir)/extras]} {
      file mkdir $sitebot(sitebotDir)/extras
      file mkdir $sitebot(sitebotDir)/extras/source
      file mkdir $sitebot(sitebotDir)/extras/misc
      file mkdir $sitebot(sitebotDir)/extras/patches
    }
    sitebot:sets cfg
  }
}

proc sitebot:loadconf {} { global sitebot sitevars configVersion
  if {![file exists $sitebot(sitebotDir)/$sitevars(config)]} {
    putlog "| SITEBOT: Config file: $sitevars(config) not in scripts dir."
    putlog "| SITEBOT: Recommended that you edit $sitebot(sitebotDir)/$sitevars(config) asap..."
    set configVersion $sitevars(currentConfigVersion)
    sitebot:updateconf
  } else {
    putlog "| SITEBOT: Config located.... loading"
    uplevel #0 {source $sitebot(sitebotDir)/$sitevars(config)}
  }
  if {![info exists configVersion]} { global configVersion
    putlog "| SITEBOT: Cant read config version number... some idiot deleted it from the conf file :)"
    set configVersion $sitevars(currentConfigVersion)
    sitebot:updateconf
  }
  if {$configVersion < $sitevars(currentConfigVersion)} {
    putlog "| SITEBOT: Config file is old updating... default values been used for"
    putlog "| SITEBOT: Missing variables strongly recommend you edit your conf.."
    
    set configVersion $sitevars(currentConfigVersion)
    sitebot:updateconf
  }
  if {$configVersion == $sitevars(currentConfigVersion)} {
    putlog "| SITEBOT: Config version matchs tcl version! Variables Read Succesfully!"
  }
  if {$configVersion > $sitevars(currentConfigVersion)} {
    putlog "| SITEBOT: Config version is newer then tcl... no changes made"
    putlog "| SITEBOT: Possibility for errors due to version mismatch"
  }
}

proc sitebot:loadapi {} { global sitebot sitevars msgtypes apiVersion
    if {![file exists $sitebot(sitebotDir)/$sitevars(api)]} {
    putlog "| SITEBOT: Api file: $sitevars(api) not in scripts dir."
    putlog "| SITEBOT: Recommended that you edit $sitebot(sitebotDir)/$sitevars(api) asap..."
    set apiVersion $sitevars(currentApiVersion)
    sitebot:updateapi
  } else {
    putlog "| SITEBOT: Api located.... loading"
    uplevel #0 {source $sitebot(sitebotDir)/$sitevars(api)}
  }
  if {![info exists apiVersion]} { global apiVersion
    putlog "| SITEBOT: Cant read api version number... some idiot deleted it from the api file :)"
    unset msgtypes
    sitebot:init
    set apiVersion $sitevars(currentApiVersion)
    sitebot:updateapi
  }
  if {$apiVersion < $sitevars(currentApiVersion)} {
    putlog "| SITEBOT: Api file is old updating... default values been used for"
    putlog "| SITEBOT: Missing variables strongly recommend you edit $sitebot(sitebotDir)/$sitevars(api)"
    sitebot:init
    set apiVersion $sitevars(currentApiVersion)
    sitebot:updateapi
  }
  if {$apiVersion == $sitevars(currentApiVersion)} {
    sitebot:servertype
    putlog "| SITEBOT: Api version matchs tcl version! Variables Read Succesfully!"
  }
  if {$apiVersion > $sitevars(currentApiVersion)} {
    putlog "| SITEBOT: Api version is newer then tcl... no changes made"
    putlog "| SITEBOT: Possibility for errors due to version mismatch"
  }
}

proc sitebot:servertype { } { global sitebot sitevars msgtypes echovars mask
  if { $sitevars(serverType) != $sitebot(serverType) } {
    putlog "| SITEBOT: Server type changed. Old type was \"$sitevars(serverType)\". New one \"$sitebot(serverType)\"."
    unset msgtypes; unset echovars; unset mask
    sitebot:sets api
    set sitevars(serverType) $sitebot(serverType)
    sitebot:updateapi
    putlog "| SITEBOT: Succesfully changed to $sitebot(serverType)!"
  }
}

proc sitebot:loadskin {} { global sitebot sitevars script proxy
  if {![file exists $sitebot(sitebotDir)/$sitevars(skin)]} {
    putlog "| SITEBOT: Skin file: $sitevars(skin) not in scripts dir."
    putlog "| SITEBOT: Downloading $sitevars(skin)"
    if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
    set www [sitebot:seturl]; if { $www == 0 } { die "ERROR: No download server online. Try again later."}
    set url "${www}sitebot-default.skin"
    set out [open $sitebot(sitebotDir)/sitebot-default.skin w] ; set tok [http::geturl $url -channel $out] ; close $out
    set result [sitebot:checkfile $sitebot(sitebotDir)/sitebot-default.skin ]
    if {$result == 0} {
      putlog "| SITEBOT: Download of sitebot-default.skin unsuccessful.. file not found"
    } {
      putlog "| SITEBOT: sitebot-default.skin Successfully Downloaded"
    }
    sitebot:loadskin; return;
  } else {
    putlog "| SITEBOT: Skin located.... loading"
    uplevel #0 {source $sitebot(sitebotDir)/$sitevars(skin)}
  }

  putlog "`+ Searching for sitebot custom skins"
  if {[catch { set scripts [glob $sitebot(sitebotDir)/sitebot-skin-*.skin] } ] != 0 } { putlog "+ No custom skin found" } {
    foreach script $scripts {
      if {[string match *$sitebot(customSkin)* $script] && $sitebot(customSkin) != "" } {
        putlog " | - Loading $script"
        uplevel #0 {source $script}
      }
    }
    putlog "+ Finished loading skins"
  }
}

proc sitebot:functions {} {
  uplevel #0 {
    if $color(enabled) {
      set c0 "\003$color(type)"
      set c1 "\003$color(standard)"
      set c2 "\003$color(highlight)"
    } { set c0 ""; set c1 ""; set c2 "" }
    set sitein [replacevar sitein "site" "$sitebot(site)"]

    if $enabled(onjoin) {
      if !$sitebot(limboBot) { bind join - * sitebot:onjoin }

      proc sitebot:onjoin { nick uhost hand chan } { global chans sitebot sitevars
        if {[string match [string tolower "*$chan*"] [string tolower $chans(DEFAULT)]]} {
          hubsend msg 5 $nick NOTICE [replacevar welcome "version" "{$sitevars(version)}"]
        }
      }
    } {
      if !$sitebot(limboBot) {
        set valid [binds sitebot:onjoin]
        if {$valid != ""} { unbind join - * sitebot:onjoin }
      }
    }

    bind dcc C ${sitebot(dccPrefix)}timers debugtimers
    proc debugtimers {hand idx args} {
      foreach this [utimers] {putlog "$this"}
      foreach this [timers] {putlog "$this"} 
    }

    bind dcc C ${sitebot(dccPrefix)}skin sitebot:setskin

    proc sitebot:setskin { hand idx arg } { global sitebot script
      if { $arg == "" } {
        putdcc $idx [header ".${sitebot(dccPrefix)}skin help" 0]
        putdcc $idx "| Usage: .${sitebot(dccPrefix)}skin <skinname>"
        putdcc $idx [footer 0]
      } {
        putdcc $idx [header ".${sitebot(dccPrefix)}skin" 0]
        if {[catch { set scripts [glob $sitebot(sitebotDir)/sitebot-skin-*.skin] } ] != 0 } { putdcc $idx "| No custom skin found" } {
           foreach script $scripts {
            if {[string match *$arg* $script]} {
              putdcc $idx  "| Loading skin $script"
              uplevel #0 {source $script}
            }
          }
        }
        putdcc $idx [footer 0]
      }
    }

    bind dcc C ${sitebot(dccPrefix)}saveconfig sitebot:dcc_saveconfig
    bind dcc C ${sitebot(dccPrefix)}saveapi sitebot:dcc_updateapi
    bind dcc C ${sitebot(dccPrefix)}savecfg sitebot:dcc_updateconf
    bind dcc C ${sitebot(dccPrefix)}set sitebot:dcc_set
    bind dcc C ${sitebot(dccPrefix)}help sitebot:corehelp
    bind dcc - ${sitebot(dccPrefix)}announce sitebot:dcc_announce

    if $enabled(version) {
      if !$sitebot(limboBot) {
        bind pub - ${sitebot(pubPrefix)}ver sitebot:version
        bind pub - ${sitebot(pubPrefix)}version sitebot:version
        bind pub - ${sitebot(pubPrefix)}build sitebot:build
      }
    }

    proc sitebot:dcc_saveconfig { hand idx arg } {
      sitebot:updateconf
      sitebot:updateapi
    }
    proc sitebot:dcc_updateapi { hand idx arg } { sitebot:updateapi }
    proc sitebot:dcc_updateconf { hand idx arg } { sitebot:updateconf }

    proc sitebot:corehelp { hand idx arg } { global sitebot
      putdcc $idx [header ".${sitebot(dccPrefix)}help" 0]
      putdcc $idx "| .${sitebot(dccPrefix)}addons - give you the help for the addon manager."
      putdcc $idx "| .${sitebot(dccPrefix)}update - is the standard sitebot update tool."
      putdcc $idx "| .${sitebot(dccPrefix)}set cfg - change config settings."
      putdcc $idx "| .${sitebot(dccPrefix)}set api - change api settings."
      putdcc $idx [footer 0]
    }
  }
}

proc sitebot:addonsearch {} { global sitebot script addons enabled
  putlog "`+ Searching for sitebot addons"
  if {[catch { set scripts [glob $sitebot(sitebotDir)/sitebot-addon-*.tcl] } ] != 0 } { putlog "+ No sitebot addons found" } {
    foreach script [lsort $scripts] {
      if { $sitebot(serverType) == "drftpd" } {
        if {[regexp "announce|bnc|help|invite" $script]} {
          putlog " | - Loading $script"
          uplevel #0 {source $script}
        }
      } {
        putlog " | - Loading $script"
        uplevel #0 {source $script}
      }
    }
    putlog "+ Finished loading addons"
  }
}

proc sitebot:checkscripts {} { global sitebot enabled
  putlog "| SITEBOT: Checking for missing files in."
  set die 0
  if {[info exists enabled(announce)]} {
    if $enabled(announce) {
      if { $sitebot(serverType) == "glftpd" } {
        if {![file exists $sitebot(glftpdDir)/bin/tail]} { putlog "SITEBOT: - missing \"tail\"" ; set die 1}
      } elseif { $sitebot(serverType) == "drftpd" } {
        if {![file exists /usr/bin/tail]} { putlog "SITEBOT: - missing \"/usr/bin/tail\"" ; set die 1}
      } { }
    }
  }
  if {$die == "1"} {
    putlog "| SITEBOT: Will not load until sitebot can find the missing files"
    uplevel #0 { die }
  }
}

proc sitebot:addversion { addonver } { 
  # set sitebotVersion "$sitebotVersion +$addonver"
}

proc sitebot:ver { nick uhost hand chan args } { sitebot:version $nick $uhost $hand $chan $args }

proc sitebot:version { nick uhost hand chan args } { global sitebot sitevars addon addonBuild
  hubsend chan 5 $chan PRIVMSG [replacedef "%sitein%c1 Is using \[%c2[b]$sitevars(version)[b]%c1\]"]
  if [info exists addon] {
    foreach type [lsort [array names addon]] { lappend type2 "[string toupper $type 0 0] $addon($type)," }
    foreach line [splitlines $type2 5] { hubsend chan 5 $chan PRIVMSG [replacedef "%sitein%c1 Addons \[[b]%c2[string replace [join $line] end end ""]%c1[b]\]"] } 
  }
}

proc sitebot:build { nick uhost hand chan arg } { global sitebot sitevars addonBuild addon
  if { $arg == ""} {
     hubsend chan 5 $chan PRIVMSG [replacedef "%sitein%c1 Sitebot build \[%c2[b]sitebot-core $sitevars(currentVersion)[b]%c1\]"]
  } elseif { $arg == "all" } {
    hubsend chan 5 $chan PRIVMSG [replacedef "%sitein%c1 Sitebot build \[%c2[b]sitebot-core $sitevars(currentVersion)[b]%c1\]"]
    foreach type [lsort [array names addon]] { lappend type2 [replacedef "%c2[b][string toupper $type 0 0][b]%c1 \[%c2[b]$addon($type).$addonBuild($type)[b]%c1\],"] }
    foreach line [splitlines $type2 5] { hubsend chan 5 $chan PRIVMSG [replacedef "%sitein%c1 Addons [string replace [join $line] end end ""]"] } 
  } {
    foreach type $arg {
      if {[info exists addonBuild($type)]} {
        hubsend chan 5 $chan PRIVMSG [replacedef "%sitein%c1 Addon %c2[b]$type[b]%c1 build \[%c2[b]$addon($type).$addonBuild($type)[b]%c1\]"]
      } {
        hubsend chan 5 $chan PRIVMSG [replacedef "%sitein%c1 No build info from addon %c2[b]$type[b]"]
      }
    }
  }
}

proc sitebot:dcc_announce {hand idx arg} { global chans
  if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?You need '.help'" ; return 0 }
  foreach chan $chans(DEFAULT) { hubsend chan 5 $chan PRIVMSG [replacevar announcement "msg" "{$arg}"] }
}

#-- ADDON MANAGER -------------------------------------------------------------------#
proc sitebot:addonmanager { } { 
  uplevel #0 {
    if $enabled(updater) {
      bind dcc C ${sitebot(dccPrefix)}addons sitebot:addons

      proc sitebot:addons {hand idx arg} {
        global sitebot sitevars file  enabled proxy
        global addon addonConf addonConfInfo addonBinds addonVersion addonBuild

        set cmd [lindex $arg 0]; set go 0
        putlog "#$hand# ${sitebot(dccPrefix)}addon $arg"
        set www [sitebot:seturl]; if { $www == 0 } { return }
        switch -exact -- $cmd {
          "list" {
            putdcc $idx [header "Addons Installed:" 10]
            if { [array names addon] == "" } {
              putdcc $idx "| There is no addon installed..."
            } {
              foreach type [lsort [array names addon]] { lappend type2 "[string toupper $type 0 0] $addon($type).$addonBuild($type)," }
              foreach line [splitlines $type2 5] { putdcc $idx "| [string replace [join $line] end end ""]" }
            }
            putdcc $idx [header "Addons available from the Net:" -7]
            set url "${www}addons/version"
            set tok [http::geturl $url] ; upvar #0 $tok state
            set counter "-1"
            foreach body [array names state] {
              set counter [expr $counter + 1]
              set file [lindex $state(body) $counter]
              if {$file == ""} {continue}
              foreach {type currentVersion newBuild} [split [string range $file 0 end] "|"] {}
              lappend addons "[string toupper $type 0 0] $currentVersion.$newBuild,"
            }
            foreach line [splitlines [lsort $addons] 5] { putdcc $idx "| [string replace [join $line] end end ""]" }
            putdcc $idx [border 12]
            putdcc $idx "| For more info about a addon, type \".${sitebot(dccPrefix)}addons info <addon_name>\""
            putdcc $idx [footer 17]
          } "get" {
            if { [lrange $arg 1 end] == "" } {putdcc $idx "Usage: .${sitebot(dccPrefix)}addons get <addon_name>" ; return 0 }
            putdcc $idx [header "Geting addon [lrange $arg 1 end]:" 0]
            foreach file [string tolower [lrange $arg 1 end]] {
              putdcc $idx "| connecting to webpage... attempting to download the addon: $file"
              set result [sitebot:httpgetfile "addons" "sitebot-addon-${file}.tcl"]
              if {$result == 0} {
                putdcc $idx "| download of $file unsuccessful.. addon doesnt exist! (.${sitebot(dccPrefix)}addons list <-- list available addons!)"
                putdcc $idx [footer 0]
                return
              } {
                putdcc $idx "| download of $file successful.."
                set url "${www}addons/require_extra"
                set tok [http::geturl $url] ; upvar #0 $tok state
                set counter "-1"
                foreach body [array names state] {
                  set counter [expr $counter + 1]
                  set line [lindex $state(body) $counter]
                  if {$line == ""} {continue}
                  foreach {type files} [split [string range $line 0 end] "|"] {}
                  if {[string match $file $type]} {
                    foreach get $files {
                      set result [sitebot:httpgetfile "" "$get"]
                      if {$result == 0} {
                        putdcc $idx "| missing file : ${www}$get"
                      } {
                        putdcc $idx "| downloaded : ${www}$get"
                        if { [string match "*tar.gz*" $get] || [string match "*tgz*" $get] } {
                          set tar [exec -- tar -xzf $sitebot(sitebotDir)/$get -C $sitebot(sitebotDir)]
                          set rm  [exec -- rm $sitebot(sitebotDir)/$get]
                          if {$tar == "" && $rm == ""} {
                            putdcc $idx "| file successful untared : $get"
                          } {
                            putdcc $idx "| something fucked when untared : $get"
                          }
                        }
                      }
                    }
                  }
                }
                putdcc $idx [header "Changelog:" 10]
                foreach line [sitebot:httpinfo "addons" "changelog" $file] { putdcc $idx $line } 
                putdcc $idx [border 10]
                putdcc $idx "| loading $sitebot(sitebotDir)/sitebot-addon-$file.tcl"
                set tempfile $file
                uplevel #0 {source $sitebot(sitebotDir)/sitebot-addon-$file.tcl}
                putdcc $idx "| download of $tempfile complete... go and edit ur $sitevars(config).."
                putdcc $idx "| then type .rehash for changes to take effect"
              }
            }
            putdcc $idx [footer 15]
            sitebot:updateapi
            sitebot:updateconf
          } "info" {
            if { [lrange $arg 1 end] == "" } {putdcc $idx "Usage: .${sitebot(dccPrefix)}addons info <addon_name>" ; return 0 }
            putdcc $idx [header "Info:" 20]
            foreach line [sitebot:httpinfo "addons" "info" [lrange $arg 1 end]] { putdcc $idx $line } 
            putdcc $idx [header "Changelog:" 10]
            foreach line [sitebot:httpinfo "addons" "changelog" [lrange $arg 1 end]] { putdcc $idx $line } 
            putdcc $idx [footer 10]
          } "del" {
            if { [lrange $arg 1 end] == "" } {putdcc $idx "Usage: .${sitebot(dccPrefix)}addons del <addon_name>" ; return 0 }
            putdcc $idx [header "Deleting addon [lrange $arg 1 end]:" -10]
            foreach file [string tolower [lrange $arg 1 end]] {
              if {![info exists addon($file)]} {
                putdcc $idx "| Addon $file isnt installed."
                putdcc $idx [footer 0]
                return 0
              }
              putdcc $idx "| request to remove addon: $file"
              putdcc $idx "| - removing $file variables"
              foreach type [lsort [array names addonConf]] {
                if {[string match $type $file]} {
                  unset addonConf($type)
                  global $type
                  if {[info exists $type]} { unset $type }
                }
              }
              foreach enable [lsort [array names enabled]] {
                foreach {type setting} [split $enable "_"] {}
                if {[string match $type $file]} {
                  unset enabled($enable)
                }
              }
              if {[info exists addonBinds($file)]} {
                if {[lsearch -exact [array names addonBinds] $file] != -1} {
                  foreach type $addonBinds($file) {
                    set valid [binds ${sitebot(pubPrefix)}$type]
                    if {$valid != ""} { unbind pub - ${sitebot(pubPrefix)}$type sitebot:$type }
                  }
                }
                unset addonBinds($file)
              }
              if {[info exists addon($file)]} { unset addon($file) }
              if {[info exists addonBuild($file)]} { unset addonBuild($file) }
              if {[info exists addonConfInfo($file)]} { unset addonConfInfo($file) }
              putdcc $idx "| - removed $file variables"
              if {![file exists $sitebot(sitebotDir)/sitebot-addon-${file}.tcl]} { putdcc $idx "| $sitebot(sitebotDir)/sitebot-addon-${file}.tcl not found." ; return 0 }
              set result [exec rm $sitebot(sitebotDir)/sitebot-addon-${file}.tcl]
              putdcc $idx "| sitebot-addon-${file}.tcl removed."
              putdcc $idx "| Please type .rehash for changes to take effect."
            }
            putdcc $idx [footer 10]
            sitebot:updateconf
          } "version" {
            putdcc $idx [header "Checking addon versions:" -5]
            set url "${www}addons/version"
            set tok [http::geturl $url] ; upvar #0 $tok state
            set counter "-1"
            foreach body [array names state] {
              set counter [expr $counter + 1]
              set file [lindex $state(body) $counter]
              if {$file == ""} {continue}
              foreach {type currentVersion newBuild} [split [string range $file 0 end] "|"] {}
              set newVersion [join $currentVersion.$newBuild]; regsub -all {\.} $newVersion "" newVersionReg
              foreach type2 [lsort [array names addon]] {
                if {[string match $type $type2]} {
                  set addonVersion [join $addon($type).$addonBuild($type)]; regsub -all {\.} $addonVersion "" addonVersionReg
                  if {$go != 0} { putdcc $idx [border 0] }
                  if { $addonVersionReg < $newVersionReg } { 
                    putdcc $idx "| [string toupper $type 0 0] v$addonVersion, Latest Version: v$newVersion" 
                    putdcc $idx "| Seems you have an old version!"
                    putdcc $idx "| \".${sitebot(dccPrefix)}update getaddon $type\" to download and install the latest version."
                  } elseif { $addonVersionReg == $newVersionReg } {
                    putdcc $idx "| [string toupper $type 0 0] v$addonVersion, Latest Version: v$newVersion" 
                    putdcc $idx "| Versions Match! Seems your uptodate!"
                  } elseif { $addonVersionReg > $newVersionReg } {
                    putdcc $idx "| [string toupper $type 0 0] v$addonVersion, Latest Version: v$newVersion"
                    putdcc $idx "| If your seeing this i mustnt be keeping my web page uptodate"
                    putdcc $idx "| or someone has changed the versions or someone else is maintaining"
                    putdcc $idx "| my script now! who knows?"
                  }
                  set go 1
                }
              }
            }
            putdcc $idx [footer 0]
          } "update" {
            putdcc $idx [header "Updating all addons:" 10]
            set url "${www}addons/version"
            set tok [http::geturl $url] ; upvar #0 $tok state
            set counter "-1"
            foreach body [array names state] {
              set counter [expr $counter + 1]
              set line [lindex $state(body) $counter]
              if {$line == ""} {continue}
              foreach {type currentVersion newBuild} [split [string range $line 0 end] "|"] {}
              set newVersion [join $currentVersion.$newBuild]; regsub -all {\.} $newVersion "" newVersionReg
              foreach type2 [lsort [array names addon]] {
                if {[string match $type $type2]} {
                  set addonVersion [join $addon($type2).$addonBuild($type2)]; regsub -all {\.} $addonVersion "" addonVersionReg
                  if {$go != 0} { putdcc $idx [border 0] }
                  if { $addonVersionReg < $newVersionReg } { 
                    putdcc $idx "| [string toupper $type2 0 0] v$addonVersion, Latest Version: v$newVersion" 
                    putdcc $idx "| connecting to webpage... attempting to download the addon: $type"
                    set result [sitebot:httpgetfile "addons" "sitebot-addon-${type}.tcl"]
                    if {$result == 0} {
                      putdcc $idx "| missing file: sitebot-addon-${type}.tcl"
                      putdcc $idx [footer 0]
                      return
                    } {
                      set url "${www}addons/require_extra"
                      set tok [http::geturl $url] ; upvar #0 $tok state2
                      set counter2 "-1"; set updated 1;
                      foreach body2 [array names state2] {
                        set counter2 [expr $counter2 + 1]
                        set line2 [lindex $state2(body) $counter2]
                        if {$line2 == ""} { }
                        foreach {type3 files} [split [string range $line2 0 end] "|"] {}
                        if {[string match $type $type3]} {
                          foreach get $files {
                            set result [sitebot:httpgetfile "" "$get"]
                            if {$result == 0} {
                              putdcc $idx "| missing file : ${www}$get"
                            } {
                              putdcc $idx "| downloaded : ${www}$get"
                              if { [string match "*tar.gz*" $get] || [string match "*tgz*" $get] } {
                                set tar [exec -- tar -xzf $sitebot(sitebotDir)/$get -C $sitebot(sitebotDir)]
                                set rm  [exec -- rm $sitebot(sitebotDir)/$get]
                                if {$tar == "" && $rm == ""} {
                                  putdcc $idx "| file successful untared : $get"
                                } {
                                  putdcc $idx "| something fucked when untared : $get"
                                }
                              }
                            }
                          }
                        }
                      }
                      putdcc $idx "| download of $type successful.."
                      putdcc $idx [border 10]
                    }
                  }
                }
              }
            }
            if {![info exists updated]} {
              putdcc $idx "| There is nothing to update. You are uptodate!"
              putdcc $idx [footer 10]
            } {
              putdcc $idx "| updated your addons. go and edit ur $sitevars(config).."
              putdcc $idx "| then type .rehash for changes to take effect"
              putdcc $idx [footer 15]
              sitebot:updateapi
              sitebot:updateconf
            }
          } default {
            putdcc $idx [header ".${sitebot(dccPrefix)}addons help" 30]
            putdcc $idx "| .${sitebot(dccPrefix)}addons version - checks to see if you have the latest addon versions."
            putdcc $idx "| .${sitebot(dccPrefix)}addons list - lists available addons."
            putdcc $idx "| .${sitebot(dccPrefix)}addons info - give you some info about a addon."
            putdcc $idx "| .${sitebot(dccPrefix)}addons get <addon_name> - download and install an addon."
            putdcc $idx "| .${sitebot(dccPrefix)}addons del <addon_name> - delete an addon from your $sitebot(sitebotDir) dir."
            putdcc $idx "| .${sitebot(dccPrefix)}addons update - updates all ur installed addons."
            putdcc $idx [footer 30]
          }
        }
      }
    }
  }
  putlog "| SITEBOT: Addon manager Loaded!"
}

#-- WEB UPDATE ----------------------------------------------------------------------#
proc sitebot:updater {} {
  uplevel #0 {
    if $enabled(updater) {
      bind dcc C ${sitebot(dccPrefix)}update sitebot:update
      if !$sitebot(limboBot) { bind pub o ${sitebot(pubPrefix)}updates sitebot:updates }

      if $enabled(autoCheckUpdater) {
        if { $timer(updater) < 60*24*2 } { set timer(updater) "60*24*2" }
        timer [expr $timer(updater)] sitebot:autochkupdate
      } 

      proc sitebot:updates { nick uhost handle chan args } { 
        if { [isop $nick $chan] } { hubsend chan 5 $chan PRIVMSG [sitebot:autochkupdate] }
      } 

      proc sitebot:autochkupdate { } { global sitebot sitevars timer chans enabled addon addonBuild addonConf
        set www [sitebot:seturl]; if { $www == 0 } { return }; set noupdates 1
        set url "${www}version"
        set tok [http::geturl $url] ; upvar #0 $tok state
        foreach {currentVersion newBuild} [split [string range [lindex $state(body) 0] 0 end] "|"] {}
        set newVersion [join $currentVersion.$newBuild]
        regsub -all {\.} $newVersion "" newVersionReg; ; regsub -all {\.} $sitevars(currentVersion) "" currentVersionReg
        if { $currentVersionReg < $newVersionReg } { 
          hubsend pub 5 $chans(DEFAULT) PRIVMSG [replacedef "%sitein%c1 New %c2[b]Sitebot[b]%c1 is out! Your Version:%c2 [b]v$sitevars(currentVersion)[b]%c1 Latest Version:%c2 [b]v$newVersion[b]"] DEFAULT
          set noupdates 0
        }
        set www [sitebot:seturl]; if { $www == 0 } { return }
        set url "${www}addons/version"
        set tok [http::geturl $url] ; upvar #0 $tok state
        set counter "-1"
        foreach body [array names state] {
          set counter [expr $counter + 1]
          set file [lindex $state(body) $counter]
          if {$file == ""} {continue}
          foreach {type currentVersion newBuild} [split [string range $file 0 end] "|"] {}
          set newVersion [join $currentVersion.$newBuild]; regsub -all {\.} $newVersion "" newVersionReg
          foreach type2 [lsort [array names addon]] {
            if {[string match $type $type2]} {
              set addonVersion [join $addon($type).$addonBuild($type)]; regsub -all {\.} $addonVersion "" addonVersionReg
              if { $addonVersionReg < $newVersionReg } {  
                hubsend pub 5 $chans(DEFAULT) PRIVMSG [replacedef "%sitein%c1 Addon%c2 [b]$type[b]%c1 updated. Your Version:%c2 [b]v$addon($type).$addonBuild($type)[b]%c1 Latest Version:%c2 [b]v$currentVersion.$newBuild[b]"] DEFAULT
                set noupdates 0
              }
            }
          }
        }
        foreach this [timers] {
          if {([string compare [lindex $this 1] "sitebot:autochkupdate"] == 0)} {
            killtimer [lindex $this 2]
          }
        }
        timer [expr $timer(updater)] sitebot:autochkupdate 
        if { $noupdates == 1 } { return [replacedef "%sitein%c1 There is nothing to update."] }
      }

      proc sitebot:update {hand idx arg} { global sitebot sitevars file enabled
        set cmd [lindex $arg 0]
        putlog "#$hand# ${sitebot(dccPrefix)}update $arg"
        set www [sitebot:seturl]; if { $www == 0 } { return }
        switch -exact -- $cmd {
          "tarball" {
            putdcc $idx "sitebot: connecting to webpage... attempting to download sitebot tarball"
            set url "${www}version" ; set tok [http::geturl $url] ; upvar #0 $tok state ; 
            foreach {currentVersion newBuild} [split [string range [lindex $state(body) 0] 0 end] "|"] {}
            set result [sitebot:httpgetfile "" "sitebot-${currentVersion}.tar.gz"]
            if {$result == 0} {
              putdcc $idx "Download of sitebot-${currentVersion}.tar.gz unsuccessful.. file not found"
            } {
              putdcc $idx "sitebot: sitebot-${currentVersion}.tar.gz Successfully Downloaded"
            }
          } "version" {
            putdcc $idx [header "Checking version." 0]
            set url "${www}version"
            set tok [http::geturl $url] ; upvar #0 $tok state
            foreach {currentVersion newBuild} [split [string range [lindex $state(body) 0] 0 end] "|"] {}
            set newVersion [join $currentVersion.$newBuild]
            regsub -all {\.} $newVersion "" newVersionReg; ; regsub -all {\.} $sitevars(currentVersion) "" currentVersionReg
            if { $currentVersionReg < $newVersionReg } { 
              putdcc $idx "| Your Version: v$sitevars(currentVersion) Latest Version: v$newVersion" 
              putdcc $idx "| Seems you have an old version!"
              putdcc $idx "| \".${sitebot(dccPrefix)}update install\" to download and install the latest version."
              putdcc $idx "| \".${sitebot(dccPrefix)}update tarball\" to just grab the latest pack."
            } elseif { $currentVersionReg == $newVersionReg } {
              putdcc $idx "| Your Version: v$sitevars(currentVersion) Latest Version: v$newVersion"
              putdcc $idx "| Versions Match! Seems your uptodate!"
            } elseif { $currentVersionReg > $newVersionReg } {
              putdcc $idx "| Your Version: v$sitevars(currentVersion) Latest Version: v$newVersion"
              putdcc $idx "| If your seeing this i mustnt be keeping my web page uptodate"
              putdcc $idx "| or someone has changed the versions or someone else is maintaining"
              putdcc $idx "| my script now! who knows?"
            }
            putdcc $idx [header "Changelog:" 10]
            set url "${www}/updateinfo"
            set tok [http::geturl $url] ; upvar #0 $tok state
            set counter "-1" ; foreach body [array names state] { 
              incr counter ; set file [lindex $state(body) $counter]
              if {$file == ""} {continue} ; putdcc $idx "| $file"
            }
            putdcc $idx [footer 10]
          } "install" {
            set choice [lindex $arg 1]
            putdcc $idx [header "Installing Sitebot:" 10]
            set url "${www}version"
            set tok [http::geturl $url] ; upvar #0 $tok state
            foreach {currentVersion newBuild} [split [string range [lindex $state(body) 0] 0 end] "|"] {}
            set newVersion [join $currentVersion.$newBuild]
            regsub -all {\.} $newVersion "" newVersionReg; ; regsub -all {\.} $sitevars(currentVersion) "" currentVersionReg
            if {$choice != "nocheck"} {
              putdcc $idx "| sitebot: checking to makesure your running an old version."
              if { $currentVersionReg < $newVersionReg } { 
                putdcc $idx "| Your Version: v$sitevars(currentVersion) Latest Version: v$newVersion"
                putdcc $idx [border 25]
              } elseif { $currentVersionReg == $newVersionReg } {
                putdcc $idx "| Your Version: v$sitevars(currentVersion) Latest Version: v$newVersion"
                putdcc $idx "| Versions Match! Seems your already uptodate! ... Exiting Update"
                putdcc $idx [footer 30] ; return 0
              } elseif { $currentVersionReg > $newVersionReg } {
                putdcc $idx "| Your Version: v$sitevars(currentVersion) Latest Version: v$newVersion"
                putdcc $idx "| If your seeing this i mustnt be keeping my web page uptodate" 
                putdcc $idx "| or someone has changed the versions or someone else is maintaining" 
                putdcc $idx "| my script now! who knows? ... Exiting Update" 
                putdcc $idx [footer 30]; return 0
              }
            }
            putdcc $idx "| connecting to webpage... attempting to upgrade.. fingers crossed :)"
            set url "${www}list"
            set tok [http::geturl $url] ; upvar #0 $tok state

            file mkdir $sitebot(sitebotDir)
            file mkdir $sitebot(sitebotDir)/extras
            file mkdir $sitebot(sitebotDir)/extras/source
            file mkdir $sitebot(sitebotDir)/extras/misc

            set counter "-1"
            foreach body [array names state] {
              incr counter ; set file [lindex $state(body) $counter] 
              if {$file == ""} {continue}
              putdcc $idx "| downloading : ${www}$file"
              set result [sitebot:httpgetfile "" "$file"]
              if {$result == 0} {
                putdcc $idx "| missing file : ${www}$file"
              } {
                putdcc $idx "| downloaded : ${www}$file"
                if { [string match "*tar.gz*" $file] } {
                  set tar [exec -- tar -xzf $sitebot(sitebotDir)/$file -C $sitebot(sitebotDir)]
                  set rm  [exec -- rm $sitebot(sitebotDir)/$file]
                  if {$tar == "" && $rm == ""} {
                    putdcc $idx "| file successful untared and removed : $file"
                  } {
                    putdcc $idx "| something fucked when untared : $file"
                  }
                }
              }
            }
            putdcc $idx [header "Changelog:" 25]
            set url "${www}/updateinfo"
            set tok [http::geturl $url] ; upvar #0 $tok state
            set counter "-1" ; foreach body [array names state] { 
              incr counter ; set file [lindex $state(body) $counter]
              if {$file == ""} {continue} ; putdcc $idx "| $file"
            }
            putdcc $idx [border 23]
            putdcc $idx "| Upgrade to SiteBot $newVersion Complete.. Type .restart for changes to take effect."
            putdcc $idx "| Please look in sitebot.changelog for changes (in your eggdrop scripts dir)"
            putdcc $idx [footer 30]
            sitebot:updateconf
            sitebot:updateapi
          } default {
            putdcc $idx [header ".supdate help" 30]
            putdcc $idx "| .${sitebot(dccPrefix)}update version - checks to see if you have the latest version."
            putdcc $idx "| .${sitebot(dccPrefix)}update tarball - downloads latest sitebot tar.gz to your $sitebot(sitebotDir) dir."
            putdcc $idx "| .${sitebot(dccPrefix)}update install - downloads and installs latest sitebot tcl."
            putdcc $idx "| .${sitebot(dccPrefix)}update install nocheck - downloads and installs latest sitebot tcl (doesnt makesure your running an old version)."
            putdcc $idx [footer 30]
          }
        }
      }
    }
  }
  putlog "| SITEBOT: Updater Loaded!"
}

#-- SAVE API ------------------------------------------------------------------------#
proc sitebot:updateapi {} {
  uplevel #0 {
    if {[file exists $sitebot(sitebotDir)/$sitevars(api)]} {
      exec mv $sitebot(sitebotDir)/$sitevars(api) $sitebot(sitebotDir)/$sitevars(api).bak
    }
    set file [open $sitevars(api) w]
    puts $file "#-- Sitebot API v$sitevars(currentApiVersion) ------------------------------------------------------------------#"
    puts $file "set apiVersion $sitevars(currentApiVersion); 	# dont touch this line."
    puts $file "set sitevars(serverType) \"$sitevars(serverType)\"; # dont touch this line."
    puts $file ""
    puts $file "set msgtypes\(RACE\) \"$msgtypes(RACE)\""
    puts $file "set msgtypes\(DEFAULT\) \"$msgtypes(DEFAULT)\""
    puts $file ""
    puts $file "set sections \"$sections\""
    puts $file ""
    puts $file "set chans(DEFAULT) \"$chans(DEFAULT)\""
    foreach type $msgtypes(DEFAULT) {
      if {![info exists chans($type)]} {set chans($type) "#xXx" }
      puts $file "set chans($type) \"$chans($type)\""
    }
    puts $file ""
    puts $file "#-- Enable/Disable Announce ----------------------------------------------------------#"
    foreach type $msgtypes(RACE) {
      if {![info exists enabled_announce($type)]} {set enabled_announce($type) "1"}
      puts $file "set enabled_announce($type) $enabled_announce($type)"
    }
    foreach type $msgtypes(DEFAULT) {
      if {![info exists enabled_announce($type)]} {set enabled_announce($type) "0"}
      puts $file "set enabled_announce($type) $enabled_announce($type)"
    }
    puts $file ""
    puts $file "#-- Sections -------------------------------------------------------------------------#"
    foreach type $msgtypes(RACE) {
      if {![info exists chans(DEFAULT-$type)]} {set chans(DEFAULT-$type) "#xXx" }
      puts $file "set chans(DEFAULT-$type) \"$chans(DEFAULT-$type)\""
    }
    puts $file ""
    foreach section $sections {
      if {![info exists sectionpath($section-path)]} {set sectionpath($section-path) "/path/not/set"}
      puts $file "set sectionpath($section-path) \"$sectionpath($section-path)\""
      foreach type $msgtypes(RACE) {
        if {![info exists chans($section-$type)]} {set chans($section-$type) "#xXx" }
        puts $file "set chans($section-$type) \"$chans($section-$type)\""
      }
      puts $file ""
    }
    puts $file "#-- Echo Variables -------------------------------------------------------------------#"
    foreach type $msgtypes(RACE) {
    if {![info exists echovars($type)]} {set echovars($type) "" }
      puts $file "set echovars($type) \"$echovars($type)\""
    }
    foreach type $msgtypes(DEFAULT) {
      if {![info exists echovars($type)]} {set echovars($type) "" }
      puts $file "set echovars($type) \"$echovars($type)\""
    }
    puts $file ""
    puts $file "#-- Mask -----------------------------------------------------------------------------#"
    foreach type $msgtypes(RACE) {
      if {![info exists mask($type)]} {set mask($type) "" }
      puts $file "set mask($type) \"[filt $mask($type)]\""
    }
    foreach type $msgtypes(DEFAULT) {
      if {![info exists mask($type)]} {set mask($type) "" }
      puts $file "set mask($type) \"[filt $mask($type)]\""
    }
    close $file
    exec mv $sitevars(api) $sitebot(sitebotDir)
    putlog "API file: $sitevars(api) updated successfully."
    unset file
  }
}

#-- SAVE CONF -----------------------------------------------------------------------#
proc sitebot:updateconf {} {
  uplevel #0 {
    if {[file exists $sitebot(sitebotDir)/$sitevars(config)]} {
      exec mv $sitebot(sitebotDir)/$sitevars(config) $sitebot(sitebotDir)/$sitevars(config).bak
    }
    set file [open $sitevars(config) w]
    puts $file "#-- Sitebot Config v$sitevars(currentConfigVersion) ---------------------------------------------------------------#"
    puts $file "set configVersion $sitevars(currentConfigVersion); 			# dont touch this line."
    puts $file ""
    puts $file "set sitebot(serverType) \"$sitebot(serverType)\"; # glftpd or drftpd. maybe ioftpd in the future."
    puts $file "set sitebot(limboBot) \"$sitebot(limboBot)\"; # if u use the bot as a limbo bot."
    puts $file ""
    puts $file "#-- Enable & Disable Functions --------------------------------------------------------#"
    foreach type [lsort [array names enabled]] {
    if {![info exists enabled($type)]} {set enabled($type) "0"}
      puts $file "set enabled($type) $enabled($type);		# (0=off/1=on)"
    }
    puts $file ""
    puts $file "#-- Prefix & Sitename -----------------------------------------------------------------#"
    puts $file "set sitebot(sitename) \"$sitebot(sitename)\"; # Full Site Name"
    puts $file "set sitebot(site) \"$sitebot(site)\"; # Short Site Name"
    puts $file "set sitebot(pubPrefix) \"$sitebot(pubPrefix)\"; # prefix before public commands."
    puts $file "set sitebot(dccPrefix) \"$sitebot(dccPrefix)\"; # Letter before commands in dcc chat"
    puts $file ""
    puts $file "set sitebot(commandsPublic) \"$sitebot(commandsPublic)\"; # site command u want to output in the chan"
    puts $file "set sitebot(commandsMsg) \"$sitebot(commandsMsg)\"; # site command u want to output in msg to the user"
    puts $file "set sitebot(commandsNotice) \"$sitebot(commandsNotice)\"; # site command u want to output in notice to user"
    puts $file ""
    puts $file "#-- Colors ----------------------------------------------------------------------------#"
    puts $file "set color(enabled) \"$color(enabled)\"; # Enable output colors"
    puts $file "set color(type) \"$color(type)\"; # Type"
    puts $file "set color(standard) \"$color(standard)\"; # Standard"
    puts $file "set color(highlight) \"$color(highlight)\"; # Highlight"
    puts $file ""
    puts $file "set sitebot(customSkin) \"$sitebot(customSkin)\"; # Name of the skin u want to use. located in the sitebot(sitebotDir)."
    puts $file ""
    puts $file "#-- Updater Proxy Setting -------------------------------------------------------------#"
    puts $file "# If you need to use a proxy to look at web pages from your shell and you"
    puts $file "# are using the update feature in the sitebot then change the following:"
    puts $file "set timer(updater) \"$timer(updater)\"; #Check for updates once everyweek."
    puts $file ""
    puts $file "set proxy(enabled) \"$proxy(enabled)\"; # 1 = yes 0 = no"
    puts $file "set proxy(host) \"$proxy(host)\"; # Proxy Host"
    puts $file "set proxy(port) \"$proxy(port)\"; # Proxy Port"
    puts $file ""
    puts $file "#-- Glftpd Location ---------- Probably dont need to change this... -------------------#"
    puts $file "set sitebot(sitebotDir) \"$sitebot(sitebotDir)\";"
    puts $file "set sitebot(glftpdDir) \"$sitebot(glftpdDir)\";"
    puts $file "set sitebot(drftpdDir) \"$sitebot(drftpdDir)\";"
    puts $file ""
    foreach type [lsort [array names addonConf]] {
      if {[info exists addonConfInfo($type)]} { puts $file "$addonConfInfo($type)" }
      foreach variable $addonConf($type) {
        if {![info exists $type\($variable\)]} { set $type\($variable\) " " }
        puts $file "set $type\($variable\) \"[filt [set $type\($variable\)]]\";"
      }
      puts $file ""
    }
    close $file
    exec mv $sitevars(config) $sitebot(sitebotDir)
    putlog "Config file: $sitevars(config) updated succesfully."
    unset file
  }
}

#-- SSET PART -----------------------------------------------------------------------#
proc sitebot:dcc_set { hand idx arg } { global sitebot setvars
  foreach line [sitebot:set $arg] { putdcc $idx $line }
}

proc sitebot:set { args } { global addon
  global enabled  color timer proxy sitebot sitevars
  global msgtypes sections sectionpath mask enabled_announce echovars types chans
  foreach globvar [array names addon] { global $globvar }

  set dynamics "sections msgtypes"

  set args [lindex $args 0]
  set type [lindex $args 0]
  set cmd [string tolower [lindex $args 1]]
  set arg [lrange $args 2 end]
  set output ""

  if {[string match "+" [string index $cmd 0]]} {
    if {[string match "*[string range $cmd 1 end]*" $dynamics]} {
      set cmd [string map -nocase "+ {}" $cmd]
      set dynamic 1
    }
  } elseif {[string match "-" [string index $cmd 0]]} {
    if {[string match "*[string range $cmd 1 end]*" $dynamics]} {
      set cmd [string map -nocase "- {}" $cmd]
      set dynamic 0
    }
  }

  if {[info exists $cmd]} {
    if {![string match *$cmd* "sitebot color mask echovars enabled chans path sectionpath enabled_announce msgtypes"] && [lsearch -exact [array names addon] $cmd] == -1} {
      lappend output [header ".${sitebot(dccPrefix)}set $cmd" 0]
      if {![info exists dynamic]} {
        if {$arg == ""} {
          lappend output "| $cmd is currently set to \"[set $cmd]\""
        } {
          if { $arg == "none" } { set arg "" }
          set [list $cmd] $arg
          lappend output "| $cmd set to \"[set $cmd]\""
          sitebot:functions
        }
        lappend output [footer 0]
      } {
        if {$arg == ""} {
          lappend output "| Usage: .${sitebot(dccPrefix)}set <+|->$cmd <variable>"
          lappend output "| $cmd is currently set to \"[set $cmd]\""
        } elseif {[lsearch -exact $cmd $arg] == -1 || $dynamic == 0} {
          if {$dynamic == "1"} {
            lappend $cmd $arg
            lappend output "| successfully added type $arg"
          } {
            set a [lsearch -exact [set $cmd] $arg]
            if { $a >= 0 } {
              set $cmd [lreplace [set $cmd] $a $a]
              lappend output "| successfully deleted type $arg"
            }
          }
          lappend output "| $cmd set to \"[set $cmd]\""
          sitebot:updateapi
        } {
          lappend output "| $arg dose allready exist!"
          lappend output "| $cmd is currently set to \"[set $cmd]\""
        }
        lappend output [footer 0]
      }
    } {
      set cmdvar [lindex $arg 0]
      set arg [lrange $arg 1 end]
      if { $type == "api" && $cmd == "chans" } { set lineLengt 4 } { set lineLengt 6 }
      lappend output [header ".${sitebot(dccPrefix)}set $cmd" 0]
      if {![info exists dynamic]} {
        if {[lsearch -exact [array names $cmd] $cmdvar] == -1} {
          lappend output "|valid variables are: "
          foreach line [splitlines [lsort [array names $cmd]] $lineLengt] { lappend output "| $line " }
        } elseif {$arg == ""} {
          lappend output "| $cmd\($cmdvar\) is currently set to \"[set $cmd\($cmdvar\)]\""
        } {
          if { $arg == "none" } { set arg "" }
          set $cmd\($cmdvar\) $arg
          lappend output "| $cmd\($cmdvar\) set to \"[set $cmd\($cmdvar\)]\""
        }
        lappend output [footer 0]
      } {
        if {[lsearch -exact [array names $cmd] $cmdvar] == -1} {
          lappend output "|valid variables are: "
          foreach line [splitlines [lsort [array names $cmd]] lineLengt] { lappend output "| $line " }
        } elseif {$arg == ""} {
          lappend output "| Usage: .${sitebot(dccPrefix)}set <+|->$cmd <type> <variable>"
          lappend output "| $cmd\($cmdvar\) is currently set to \"[set $cmd\($cmdvar\)]\""
        } elseif {[lsearch -exact [set $cmd\($cmdvar\)] $arg] == -1 || $dynamic == "0"} {
          if {$dynamic == "1"} {
            lappend $cmd\($cmdvar\) $arg
            lappend output "| successfully added type $arg"
          } {
            set a [lsearch -exact [set $cmd\($cmdvar\)] $arg]
            if { $a >= 0 } {
              set $cmd\($cmdvar\) [lreplace [set $cmd\($cmdvar\)] $a $a]
              unset echovars($arg) ; unset mask($arg) ; unset enabled_announce($arg)
              lappend output "| successfully deleted type $arg"
            }
          }
          lappend output "| $cmd\($cmdvar\) set to \"[set $cmd\($cmdvar\)]\""
          sitebot:updateapi
        } {
          lappend output "| type $arg dose allready exist!"
          lappend output "| $cmd\($cmdvar\) is currently set to \"[set $cmd\($cmdvar\)]\""
        }
        lappend output [footer 0]
      }
    }
  } {
   if { $type == "cfg" } {
    lappend output [header ".${sitebot(dccPrefix)}set cfg help" 0]
    lappend output "| Usage: .${sitebot(dccPrefix)}set cfg <value>"
    lappend output [border 0]
    lappend output "| valid variables in \($sitevars(config)\): "
    lappend output "|  sitebot <sitename | site | pubPrefix | dccPrefix | glftpdDir>"
    lappend output "| colors: "
    lappend output "|  color <type | standard | highlight>"
    lappend output "|  bit more complex variables: "
    lappend output "|  enabled <field> <0 | 1> "
    lappend output "|  timer <updater | leafchk> <value> "
    lappend output "|  proxy <enabled | host | port> <value> "
    lappend output "|"
    lappend output "| valid addon variables \($sitevars(config)\): "
    foreach type [array names addon] { foreach line [splitlines [lsort [array names $type]] 5] { lappend output "|  $type: $line" } }
    lappend output [footer 0]
   } elseif { $type == "api" } { 
    lappend output [header ".${sitebot(dccPrefix)}set api help" 0]
    lappend output "| Usage: .${sitebot(dccPrefix)}set api <value>"
    lappend output [border 0]
    lappend output "| valid variables in \($sitevars(api)\):"
    lappend output "|  <+|->msgtypes <RACE | DEFAULT> <type>"
    lappend output "|  <+|->sections <sectionname>"
    lappend output "|  enabled_announce <type> <0 | 1>"
    lappend output "|  sectionpath <sectionname> <where to>"
    lappend output "|  chans <sectionname> <type> <channels>"
    lappend output "|  echovars <type> <info>"
    lappend output "|  mask <type> <mask>"
    lappend output "|"
    lappend output "| valid types are: "
    foreach type [array names msgtypes] { foreach line [splitlines [lsort $msgtypes($type)] 6] { lappend output "|  $type: $line" } }
    lappend output "|"
    lappend output "| valid fields for enabled are:"
    foreach line [splitlines [lsort [array names enabled]] 6] { lappend output "|  $line" }
    lappend output [footer 0]
   } {
    lappend output [header ".${sitebot(dccPrefix)}set help" 0]
    lappend output "| .${sitebot(dccPrefix)}set cfg - change config settings."
    lappend output "| .${sitebot(dccPrefix)}set api - change api settings."
    lappend output [footer 0]
   }
  }
  return $output
}

#-- HUB PART ------------------------------------------------------------------------#
proc sitebot:hub {} {
  uplevel #0 {
    bind bot - leafhere leafadd
    bind bot - leafcmd leafcmd
    bind bot - leafrehash leafrehash
    bind link - * leaflink
    bind disc - * leafdisc
    bind evnt - prerehash hubupdateid

    utimer 5 leafchk

    bind dcc C ${sitebot(dccPrefix)}leafbots botsconn

    proc botsconn {hand idx args} { global leafbots
      foreach leaf [lsort [array names leafbots]] {
        putdcc $idx " Leaf Name: $leaf" ; putdcc $idx " Flags: [lindex $leafbots($leaf) 0] ID: [lindex $leafbots($leaf) 1]"
      }
    }

    proc hubupdateid {type} { global hubid
      if {[info exists hubid]} { set hubid [rand 999999]}
    }

    proc leafrehash {hand idx arg} { putlog "SITEBOT: Got a leaf rehash from $hand"; leafchk }

    proc leafchk {} { global botnick sitebot hubid timer
      putallbots "leafchk $sitebot(pubPrefix) $hubid {$sitebot(sitename)}"
      putlog "SITEBOT: Checking leafs"
      foreach this [timers] {
        if {([string compare [lindex $this 1] "leafchk"] == 0)} {
          killtimer [lindex $this 2]
        }
      }
      timer [expr $timer(leafchk)] leafchk
    }

    proc leaflink {botname via} { global botnick sitebot hubid
      putbot $botname "leafchk $sitebot(pubPrefix) $hubid {$sitebot{sitename}}"
      putlog "SITEBOT: Checking linked bot $botname. Thats connecting through $via."
    }

    proc leafdisc {botname} { global leafbots
      if {[info exists leafbots($botname)]} { putlog "SITEBOT: Disconnected bot $botname" }
      if {[info exists leafbots($botname)]} { unset leafbots($botname)}
    }

    proc leafadd {hand idx arg} { global leafbots
      if {[string match *$hand* [lsort [array names leafbots]]]} {
        if {![string match [lindex $arg 1] [lindex $leafbots($hand) 1]]} {
          set leafbots($hand) "$arg"
          putlog " Changed Leaf: $hand" ; putlog " Flags: [lindex $leafbots($hand) 0] ID: [lindex $leafbots($hand) 1]"
        }
      } {
        set leafbots($hand) "$arg"
        putlog " Found Leaf: $hand" ; putlog " Flags: [lindex $leafbots($hand) 0] ID: [lindex $leafbots($hand) 1]"
      }
    }

    proc leafcmd {hand idx args} { global enabled sitebot
      if $enabled(debug) { putlog "DEBUG: Incoming leaf command $args" }
      eval [lindex $args 0]
    }

    proc hubsend {mtype flag dest args output {cmd "nothing"} {section ""}} { global sitebot leafbots enabled
      if { [string match "* *" $dest] } { 
        foreach {chans nick} [split $dest " "] { }
      }
      if {[regexp "$cmd" $sitebot(commandsPublic)]} { set mtype "chan"; set args "PRIVMSG";set dest $chans }
      if {[regexp "$cmd" $sitebot(commandsMsg)]} { set mtype "msg"; set args "PRIVMSG"; set dest $nick }
      if {[regexp "$cmd" $sitebot(commandsNotice)]} { set mtype "msg"; set args "NOTICE"; set dest $nick }
      if { $cmd != "nothing" && $mtype == "msg" } { set dest $nick }
      if { $cmd != "nothing" && $mtype == "chan" } { set dest $chans }
      if $enabled(debug) { putlog "DEBUG: Msg type: $mtype Flag: $flag Dest: $dest Args: $args Section: $section Command: $cmd Output: $output" }
      regsub -all {::} $output "\n" output

      switch $mtype {
        msg {
          if {[llength $dest] > 1} {
            foreach {leaf leafnick} $dest {}
            if [regexp $flag [lindex $leafbots($leaf) 0]] {
              set str "leafmsg" ; lappend str $args $leafnick $output 
              putbot $leaf $str
            }
          } {
            if { [string match "*\n*" $output] } { 
              foreach line [split $output "\n"] { puthelp "$args $dest :$line" }
            } {
              puthelp "$args $dest :$output" 
            }
          }
        } pub {
          foreach leaf [array names leafbots] {
            if [regexp $flag [lindex $leafbots($leaf) 0]] {
              set str "leafpub" ; lappend str $args $section $output 
              putbot $leaf $str
            }
          }
          if { [string match "*\n*" $output] } { 
            foreach line [split $output "\n"] { foreach chan $dest { putquick "$args $chan :$line" } }
          } {
            foreach chan $dest { putquick "$args $chan :$output" }
          }
        } chan { 
          if {[llength $dest] > 1} {
            foreach {leaf chan} $dest {}
            if [regexp $flag [lindex $leafbots($leaf) 0]] {
              set str "leafchan" ; lappend str $args $chan $output
              putbot $leaf $str
            }
          } {
            if { [string match "*\n*" $output] } { 
              foreach line [split $output "\n"] { foreach chan $dest { putquick "$args $chan :$line" } }
            } {
              foreach chan $dest { putquick "$args $chan :$output" }
            }
          }
        }
      }
    }
  }
}

#-- FUNCTIONS----------------------------------------------------------------------#
proc n {} {return "\n"}; proc u {} {return "\037"}; proc r {} {return "\026"};
proc b {} {return "\002"}; proc c {} {return "\003"}; proc a {} {return "\001"};
proc putchanreq { chan msg } { global showrequest ; if {$showrequest == "1"} { putserv "PRIVMSG $chan : $msg" } { return 0 }; };
proc putchan { chan msg } { putserv "PRIVMSG $chan : $msg" };
proc putnot { nick msg } { putserv "NOTICE $nick : $msg" };
proc putmsg { nick msg } { putserv "PRIVMSG $nick : $msg" };
proc putnm { nick not } { global outputt ; if {$outputt == "1"} { putmsg $nick $not ; return 0 } ; putnot $nick $not ; return 0 };

proc header { arg paddLength } { return "+--\[ $arg \][padding $paddLength "-"]-------------------- -- --- - - -" }
proc footer { paddLength } { return "`[padding $paddLength "-"]---------------------- -- \[ [b]Sitebot[b] \] - - " }
proc border { paddLength } { return "+[padding $paddLength "-"]---------------------------------- - - -" }

proc padding { length with } {
  set padding $with
  set length [expr $length + 10]
  while { 0 < $length } { set padding "$padding$with"; incr length -1 }
  return $padding
}

proc filt {data} {
  regsub -all -- \\\\ $data \\\\\\\\ data; regsub -all -- \\\[ $data \\\\\[ data; regsub -all -- \\\] $data \\\\\] data
  regsub -all -- \\\} $data \\\\\} data; regsub -all -- \\\{ $data \\\\\{ data; regsub -all -- \\\" $data \\\\\" data
  regsub -all -- \\\& $data \\\\\& data;return $data
}

proc str { string key with } {
  regsub -all -nocase "$key" $string "$with" string;return $string
}

proc find { list value } {
  set a [lsearch -exact $list $value]
  if { $a >= 0 } { return 1 } { return 0 }
}

proc ldelete { list value } {
  set a [lsearch -exact $list $value]
  if { $a >= 0 } {
    return [lreplace $list $a $a]
  } else {
    return $list 
  }
}

proc strreplace { string key with } {
  if ![string match "*$key*" $string] { return $string }
  set t1 [string range $string 0 [expr [string first $key $string] -1]]
  set t2 [string range $string [expr [string first $key $string] + [string length $key]] end]
  return "${t1}${with}${t2}"
}

proc splitlines { info length } {
  set times [expr [llength $info] / $length ]
  set extra [lrange $info [expr [llength $info] - [expr [llength $info] - [expr $times * $length ]]] end]
  set output ""; set l 0
  for {set i 0} {$i<$times} {incr i} {
    set output1 ""
    set limit [expr $length + $l ]
    for {} {$l<$limit} {incr l} { append output1 "[lindex $info $l] " }
    lappend output [string trimright $output1 " "]
  }
  if { $extra != "" } { lappend output $extra }
  return $output
}

proc fixtime { time } {
  set days 0; set hours 0; set mins 0; set secs $time
  # set secs [expr $time / 1000];
  if { $secs < 0 } { set secs [expr $secs * -1] } 

  while { $secs >= 86400 } { set days [expr $days + 1]; incr secs -86400 } 
  while { $secs >= 3600 } { set hours [expr $hours + 1]; incr secs -3600 }
  while { $secs >= 60 } { set mins [expr $mins + 1]; incr secs -60 }

  if { $secs > 0 } { set time "${secs}s" }
  if { $mins > 0 } { set time "${mins}m ${secs}s" }
  if { $hours > 0 } { set time "${hours}h ${mins}m ${secs}s" }
  if { $days > 0 } { set time "${days}days ${hours}h ${mins}m ${secs}s" }

  return $time
}

proc fixsize { size } { global sitebot
  if {$size == ""} { return [b][b] }
  if { $sitebot(serverType) == "drftpd" } {
    set size [expr $size / 1000]
  }
  if {$size >= 1073741824} {
    return [replacedef "[round [expr ($size / 1073741824.0) * 1] 2][b]%c1tB[b]"]
  } elseif {$size >= 1048576} {
    return [replacedef "[round [expr $size / 1048576.0] 2][b]%c1gB[b]"]
  } elseif {$size >= 1024} {
    return [replacedef "[round [expr $size / 1024.0] 2][b]%c1mB[b]"]
  } else {
    return [replacedef "${size}[b]%c1kB[b]"]
  }
}

proc fixbigsize { size } {
  if {$size >= 1073741} {
   return [replacedef "[round [expr ($size / 1073741.0) * 1] 2][b]%c1tB[b]"]
  } elseif {$size >= 1048} {
    return [replacedef "[round [expr $size / 1048.0] 2][b]%c1gB[b]"]
  } elseif {$size >= 1} {
    return [replacedef "[round [expr $size / 1.0] 2][b]%c1mB[b]"]
  } else {
    return [replacedef "${size}[b]%c1kB[b]"]
  }
}

proc round { num dec } {
  if {[string first . $num] != -1} {
    set num [string range $num 0 [expr [string first . $num] + $dec]]
    set num [fixlenc $num [expr [string first . $num] + $dec + 1] 0]
    return $num
  } else {
    append num "." ;
    set num [fixlenc $num [expr [string first . $num] + $dec + 1] 0]
    return $num
  }
}

proc fixlenc { txt len char } {
  while {[string length $txt] < $len} { append txt $char }
  return $txt
}

proc replacevar { type key with } { global c0 c1 c2 sitein sitebot skin
  set count -1
  foreach value $key {
    set count [expr $count + 1]
    set procinput($value) [lindex $with $count]
  }
  set output "$skin($type)"
  foreach value $key {
    set myoutput $procinput($value)
    if {[string match "*%$value*" $output ]} {set output [str $output %$value $myoutput]}
  } 
  if {[string match "*%sitein*" $output ]} {set output [str $output %sitein $sitein]}
  if {[string match "*%sitename*" $output ]} {set output [str $output %sitename $sitebot(sitename)]}
  if {[string match "*%c0*" $output ]} {set output [str $output %c0 $c0]}
  if {[string match "*%c1*" $output ]} {set output [str $output %c1 $c1]}
  if {[string match "*%c2*" $output ]} {set output [str $output %c2 $c2]}
  if {[string match "*%prefix*" $output ]} {set output [str $output %prefix $sitebot(pubPrefix)]}
  return $output 
}

proc replacedef { output } { global c0 c1 c2 sitein sitebot 
  if {[string match "*%sitein*" $output ]} {set output [str $output %sitein $sitein]}
  if {[string match "*%sitename*" $output ]} {set output [str $output %sitename $sitebot(sitename)]}
  if {[string match "*%c0*" $output ]} {set output [str $output %c0 $c0]}
  if {[string match "*%c1*" $output ]} {set output [str $output %c1 $c1]}
  if {[string match "*%c2*" $output ]} {set output [str $output %c2 $c2]}
  return $output 
}

proc replacedefskin { type } { global skin
  set output "$skin($type)"
  set output [replacedef $output]
  return $output 
}

proc rel { fpath } {
  set split [split $fpath "/"];
  set ll [llength $split];
  if {$ll < 3} { return "\{ERR\} \{ERR\}"; }
  set loc "[lindex $split [expr $ll - 2]]";
  set rel "[lindex $split [expr $ll - 1]]";
  if {[string match "\[cC\]\[dD\]\[0-9\]" $rel] || [string match "\[dD\]\[iI\]\[sS\]\[cCkK\]*" $rel] || [string match "\[sS\]\[aA\]\[mM\]\[pP\]\[lL\]\[eE\]*" $rel] || 
      [string match "\[cC\]\[oO\]\[vV\]\[eE\]\[rR\]" $rel] || [string match "\[pP\]\[aA\]\[rR\]\[tT\]*" $rel]} {
    set loc "[lindex $split [expr $ll - 3]]";
    set rel "[lindex $split [expr $ll - 2]]/$rel";
  }
  return "\{$loc\} \{$rel\}";
}

proc sitebot:checkfile {fn} {
  set check [open $fn r]
  gets $check line
  if {[string index $line 0] == "<"} {
    close $check
    file delete $fn
    return 0
  }
  close $check ; return 1
}

proc sitebot:seturl {} { global urlList enabled proxy
  if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
  foreach url $urlList {
    set err [catch {::http::geturl $url -timeout 10000} token]

    if { $err } { 
      if $enabled(debug) { putlog "DEBUG: $url offline" }
      ::http::cleanup $token
    } else {
      ::http::cleanup $token
      return $url
    }
  }
  return 0
}

proc sitebot:httpgetfile { dir file } { global sitebot proxy
  if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
  set www [sitebot:seturl]; if { $www == 0 } { return }
  set url "${www}$dir/$file"
  set out [open $sitebot(sitebotDir)/$file w] ; set tok [http::geturl $url -channel $out] ; close $out
  set result [sitebot:checkfile $sitebot(sitebotDir)/$file]
  return $result
}

proc sitebot:httpinfo { dir page file } { global proxy
  set output ""
  if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
  set www [sitebot:seturl]; if { $www == 0 } { return }
  set url "${www}$dir/$page"
  set tok [http::geturl $url] ; upvar #0 $tok state
  set counter "-1"
  foreach body [array names state] {
    set counter [expr $counter + 1]
    set line [lindex $state(body) $counter]
    if {$line == ""} {continue}
    foreach {type change} [split [string range $line 0 end] "|"] {}
    if {[string match $file $type]} {
      foreach line [split $change ";"] { lappend output "| $line" }
      set found 1
    }
  }
  if {![info exists found] } { lappend output "| Nothing found about $file." }
  return $output
}

proc readfile {filename} { 
  set of "1" ; set llist ""
  catch {open $filename r} of
  if ![string match "file*" $of] {return "e"}
  set size [file size $filename]
  if {$size > 1} {set llist [read $of $size]}
  close $of
  return $llist
}

proc sitebot:sets { type } {
  if { $type == "cfg" } {
    uplevel #0 {
      if {![info exists addonExtraTimer]} { set addonExtraTimer "" }
      if {![info exists sitebot(serverType)]} { set sitebot(serverType) "glftpd" }
      if {![info exists sitevars(serverType)]} { set sitevars(serverType) "glftpd" }
      if {![info exists sitebot(limboBot)]} { set sitebot(limboBot) 0 }
      if {![info exists enabled(updater)]} { set enabled(updater) 1 }
      if {![info exists enabled(onjoin)]} { set enabled(onjoin) 0 }
      if {![info exists enabled(autoCheckUpdater)]} { set enabled(autoCheckUpdater) 0 }
      if {![info exists enabled(debug)]} { set enabled(debug) 0 }
      if {![info exists enabled(version)]} { set enabled(version) 1 }
      if {![info exists sitebot(sitename)]} { set sitebot(sitename) "The p0rn SiTE" }
      if {![info exists sitebot(site)]} { set sitebot(site) "xXx" }
      if {![info exists sitebot(pubPrefix)]} { set sitebot(pubPrefix) "!x" }
      if {![info exists sitebot(dccPrefix)]} { set sitebot(dccPrefix) "s" }
      if {![info exists sitebot(commandsPublic)]} { set sitebot(commandsPublic) "" }
      if {![info exists sitebot(commandsMsg)]} { set sitebot(commandsMsg) "" }
      if {![info exists sitebot(commandsNotice)]} { set sitebot(commandsNotice) "" }
      if {![info exists timer(updater)]} { set timer(updater) "60*24*7" }
      if {![info exists timer(leafchk)]} { set timer(leafchk) "30" }
      if {![info exists proxy(enabled)]} { set proxy(enabled) 0 }
      if {![info exists proxy(host)]} { set proxy(host) "myproxy.isp.com" }
      if {![info exists proxy(port)]} { set proxy(port) "8080" }
      if {![info exists color(enabled)]} { set color(enabled) 1 }
      if {![info exists color(type)]} { set color(type) "" }
      if {![info exists color(standard)]} { set color(standard) "14" }
      if {![info exists color(highlight)]} { set color(highlight) "" }
      if {![info exists sitebot(customSkin]} { set sitebot(customSkin) "" }
      if {![info exists sitebot(glftpdDir)]} { set sitebot(glftpdDir) "/glftpd" }
      if {![info exists sitebot(drftpdDir)]} { set sitebot(drftpdDir) "/drftpd" }
      if {![info exists hubid]} { set hubid [rand 999999]}
    }
  } elseif { $type == "api" } {
    uplevel #0 {
      if { $sitebot(serverType) == "glftpd" } {
        if {![info exists msgtypes(RACE)]} { set msgtypes(RACE) "PRE NEWDIR SFV VIDEO_INFO UPDATE UPDATEAUDIO UPDATEZIP HALFWAY RACEHALFWAY RACE NEWLEADER COMPLETE RACECOMPLETE STATS USERSTATS GROUPSTATS ONELINESTATS DELDIR INCOMPLETE WIPE-R NUKE UNNUKE" }
        if {![info exists msgtypes(DEFAULT)]} { set msgtypes(DEFAULT) "LOGIN LOGOUT" }
        if {![info exists echovars(SFV)]} { set echovars(SFV) "pf release files" }
        if {![info exists echovars(UPDATE)]} { set echovars(UPDATE) "pf type user group release mb" }
        if {![info exists echovars(UPDATEAUDIO)]} { set echovars(UPDATEAUDIO) "pf type release files artist year" }
        if {![info exists echovars(UPDATEZIP)]} { set echovars(UPDATEZIP) "pf type release mb files" }
        if {![info exists echovars(NEWLEADER)]} { set echovars(NEWLEADER) "pf user group mb files percent speed release " }
        if {![info exists echovars(COMPLETE)]} { set echovars(COMPLETE) "pf type release mb files speed time racers groups fast_user fast_group fast_speed" }
        if {![info exists echovars(RACECOMPLETE)]} { set echovars(RACECOMPLETE) "pf type release mb files speed time racers groups comp fast_user fast_group fast_speed slow_user slow_group slow_speed" }
        if {![info exists echovars(LOGIN)]} { set echovars(LOGIN) "hostname ip user group tagline" }
        if {![info exists echovars(LOGOUT)]} { set echovars(LOGOUT) "hostname ip user group tagline" }
        if {![info exists echovars(VIDEO_INFO)]} { set echovars(VIDEO_INFO) "pf program_stream_type program_avg_bit_rate video_mpeg_type video_frame_rate video_horizontal_size video_vertical_size video_aspect_ratio audio_mpeg_type audio_bitrate audio_sampling_frequency audio_mode" }
        if {![info exists echovars(INCOMPLETE)]} { set echovars(INCOMPLETE) "pf user group release" }
        if {![info exists echovars(RACE)]} { set echovars(RACE) "pf user group racers release speed" }
        if {![info exists echovars(HALFWAY)]} { set echovars(HALFWAY) "pf type release user group mb files percent speed" }
        if {![info exists echovars(RACEHALFWAY)]} { set echovars(RACEHALFWAY) "pf type release user group mb files percent speed gtop gmb gfiles gpercent gspeed" }
        if {![info exists echovars(USERSTATS)]} { set echovars(USERSTATS) "pf type place user group mb files percent speed" }
        if {![info exists echovars(GROUPSTATS)]} { set echovars(GROUPSTATS) "pf type place group mb files percent speed" }
        if {![info exists echovars(STATS)]} { set echovars(STATS) "pf text" }
        if {![info exists echovars(WIPE-R)]} { set echovars(WIPE-R) "pf user group tagline" }
        if {![info exists mask(SFV)]} { set mask(SFV) "%sitein%c0 [b]SFV%c1:[b] Got SFV for%c2 %release%c1. Expecting%c2 [b]%files[b]%c1F." }
        if {![info exists mask(UPDATE)]} { set mask(UPDATE) "%sitein%c0 [b]UPDATE%c1:%c2 %user[b]%c1 /%c2 %group%c1 was the first to upload file in%c2 %release%c1. Expecting%c2 [b]%mb[b]%c1mB." }
        if {![info exists mask(UPDATEAUDIO)]} { set mask(UPDATEAUDIO) "%sitein%c0 [b]UPDATE%c1:[b] Got MP3 info for%c2 %release%c1. Expecting%c2 [b]%files[b]%c1F of%c2 [b]%artist[b]%c1 from%c2 [b]%year[b]%c1." }
        if {![info exists mask(UPDATEZIP)]} { set mask(UPDATEZIP) "%sitein%c0 [b]UPDATE%c1:b[b] Got DiZ for%c2 [b]%release[b]%c1. Expecting%c2 [b]%mb[b]%c1mB in%c2 [b]%files[b]%c1F." }
        if {![info exists mask(NEWLEADER)]} { set mask(NEWLEADER) "%sitein%c0 [b]NEW LEADER%c1:%c2 %user[b]%c1 /%c2 %group%c1 takes the lead in%c2 %release%c1 / \[%c2[b]%mb[b]%c1mB%c2 [b]%files[b]%c1F%c2 [b]%percent[b]%c1%%c2 [b]%speed[b]%c1kB/s\]." }
        if {![info exists mask(COMPLETE)]} { set mask(COMPLETE) "%sitein%c0 [b]COMPLETE%c1:[b]%c2 %release%c1 \[%c2[b]%mb[b]%c1mB%c2 [b]%files[b]%c1F at%c2 [b]%speed[b]%c1kB/s -%c2 %time%c1\] was completed by%c2 [b]%racers[b]%c1 racer(s) from%c2 %groups%c1 groups(s). Fastest upload by%c2 [b]%fast_user[b]%c1 /%c2 %fast_group%c1 at%c2 [b]%fast_speed[b]%c1kB/s." }
        if {![info exists mask(RACECOMPLETE)]} { set mask(RACECOMPLETE) "%sitein%c0 [b]COMPLETE%c1:[b]%c2 %release%c1 \[%c2[b]%mb[b]%c1mB%c2 [b]%files[b]%c1F at%c2 [b]%speed[b]%c1kB/s -%c2 %time%c1\] was completed by%c2 [b]%racers[b]%c1 racer(s) from%c2 %groups%c1 groups(s). Compression method: m%c2[b]%comp[b]%c1. Fastest upload by%c2 [b]%fast_user[b]%c1 /%c2 %fast_group%c1 at%c2 [b]%fast_speed[b]%c1kB/s. Slowest upload by%c2 [b]%slow_user[b]%c1 /%c2 %slow_group%c1 at%c2 [b]%slow_speed[b]%c1kB/s." }
        if {![info exists mask(VIDEO_INFO)]} { set mask(VIDEO_INFO) "%sitein%c0 [b]SAMPLE%c1:[b]%c2 [b]%rel[b] %c1\[%c0[b]STREAM[b]%c1:%c2 [b]%program_stream_type[b]%c1@%c2[b]%program_avg_bit_rate[b]%c1kbps\] \[%c0[b]ViDEO[b]%c1:%c2 [b]MPEG-%video_mpeg_type %video_frame_rate[b]%c1fps%c2 [b]%video_horizontal_size[b]%c1x%c2[b]%video_vertical_size[b]%c1px%c2 [b]%video_aspect_ratio[b]%c1ar\] \[%c0[b]AUDiO[b]%c1:%c2 [b]%audio_mpeg_type[b]%c1@%c2[b]%audio_bitrate[b]%c1kbps%c2 [b]%audio_sampling_frequency[b]%c1Hz%c2 [b]%audio_mode[b]%c1\]." }
        if {![info exists mask(INCOMPLETE)]} { set mask(INCOMPLETE) "%sitein%c0 [b]iNCOMPLETE%c1:%c2 %user[b]%c1 /%c2 %group%c1 deletede file(s) from%c2 %release%c1. Release is now%c2 [b]incomplete[b]%c1." }
        if {![info exists mask(LOGIN)]} { set mask(LOGIN) "%sitein%c0 [b]LOGiN%c1:[b]%c2 [b]%user[b]%c1 /%c2 %group%c1 just logged in." }
        if {![info exists mask(LOGOUT)]} { set mask(LOGOUT) "%sitein%c0 [b]LOGOUT%c1:[b]%c2 [b]%user[b]%c1 /%c2 %group%c1 just logged out." }
        if {![info exists mask(RACE)]} { set mask(RACE) "%sitein%c0 [b]NEW RACER%c1:%c2 %user[b]%c1 /%c2 %group%c1 is racing \[%c2 %racers %c1\] on%c2 %release%c1 @%c2 [b]%speed[b]%c1kB/s." }
        if {![info exists mask(HALFWAY)]} { set mask(HALFWAY) "%sitein%c0 [b]HALFWAY%c1:[b]%c2 %release%c1 is in halfway. Leading uploader is%c2 [b]%user[b]%c1 /%c2 %group%c1 \[%c2[b]%mb[b]%c1mB%c2 [b]%files[b]%c1F%c2 [b]%percent[b]%c1%%c2 [b]%speed[b]%c1kB/s\]." }
        if {![info exists mask(RACEHALFWAY)]} { set mask(RACEHALFWAY) "%sitein%c0 [b]HALFWAY%c1:[b]%c2 %release%c1 is in halfway. Leading uploader is%c2 [b]%user[b]%c1 /%c2 %group%c1 \[%c2[b]%mb[b]%c1mB%c2 [b]%files[b]%c1F%c2 [b]%percent[b]%c1%%c2 [b]%speed[b]%c1kB/s \]. Leading group is%c2 [b]%gtop[b]%c1 \[%c2[b]%gmb[b]%c1mB%c2 [b]%gfiles[b]%c1F%c2 [b]%gpercent[b]%c1%%c2 [b]%gspeed[b]%c1kB/s\]." }
        if {![info exists mask(USERSTATS)]} { set mask(USERSTATS) "%sitein%c2 %place%c1.%c2 [b]%user[b]%c1 /%c2 %group%c1 \[%c2[b]%mb[b]%c1mB%c2 [b]%files[b]%c1F%c2 [b]%percent[b]%c1%%c2 [b]%speed[b]%c1kB/s\]." }
        if {![info exists mask(GROUPSTATS)]} { set mask(GROUPSTATS) "%sitein%c2 %place%c1.%c2 [b]%group[b]%c1 \[%c2[b]%mb[b]%c1mB%c2 [b]%files[b]%c1F%c2 [b]%percent[b]%c1%%c2 [b]%speed[b]%c1kB/s\]." }
        if {![info exists mask(STATS)]} { set mask(STATS) "%sitein%c2 %text" }
        if {![info exists mask(WIPE-R)]} { set mask(WIPE-R) "%sitein%c0 [b]WiPE%c1:%c2 %user[b]%c1 /%c2 %group%c1 just wiped%c2 [b]%rel[b]%c1." }
      } elseif { $sitebot(serverType) == "drftpd" } {
        if {![info exists msgtypes(RACE)]} { set msgtypes(RACE) "PRE NEWDIR HALFWAY RACE COMPLETE STATS STATSUSER STATSGROUP ONELINESTATS DELDIR WIPE NUKE UNNUKE" }
        if {![info exists msgtypes(DEFAULT)]} { set msgtypes(DEFAULT) "REQUEST REQFILLED SLAVEONLINE SLAVEOFFLINE SHUTDOWN" }
        if {![info exists echovars(COMPLETE)]} { set echovars(COMPLETE) "pf mb files speed time racers groups fast_user fast_group fast_speed" }
        if {![info exists echovars(RACE)]} { set echovars(RACE) "pf user group speed files_left race_time" }
        if {![info exists echovars(HALFWAY)]} { set echovars(HALFWAY) "pf user group mb files percent speed leftfiles" }
        if {![info exists echovars(STATS)]} { set echovars(STATS) "pf text" }
        if {![info exists echovars(STATSUSER)]} { set echovars(STATSUSER) "pf place user group mb files percent speed" }
        if {![info exists echovars(STATSGROUP)]} { set echovars(STATSGROUP) "pf place group mb files percent speed" }
        if {![info exists echovars(REQUEST)]} { set echovars(REQUEST) "pf user group tagline" }
        if {![info exists echovars(REQFILLED)]} { set echovars(REQFILLED) "pf user group tagline" }
        if {![info exists echovars(SLAVEONLINE)]} { set echovars(SLAVEONLINE) "slave msg totalspace freespace" }
        if {![info exists echovars(SLAVEOFFLINE)]} { set echovars(SLAVEOFFLINE) "slave msg" }
        if {![info exists echovars(SHUTDOWN)]} { set echovars(SHUTDOWN) "msg" }
        if {![info exists echovars(WIPE)]} { set echovars(WIPE) "pf user group tagline" }
        if {![info exists mask(COMPLETE)]} { set mask(COMPLETE) "%sitein%c0 [b]COMPLETE%c1:[b]%c2 [b]%rel%c1[b] \[ %c2[b]%mb[b] %c2[b]%files[b]%c1F at%c2 [b]%speed[b]/s -%c2 %time%c1\] was completed by%c2 [b]%racers[b]%c1 racer(s) from%c2 %groups%c1 groups(s). Fastest upload by %c2[b]%fast_user[b]%c1 /%c2 %fast_group%c1 at%c2 [b]%fast_speed[b]/s." }
        if {![info exists mask(RACE)]} { set mask(RACE) "%sitein%c0 [b]NEW RACER%c1:%c2 %user[b]%c1 /%c2 %group%c1 is joining on%c2 [b]%rel[b]%c1 @%c2 [b]%speed[b]%c1/s and%c2 [b]%files_left[b]%c1F left." }
        if {![info exists mask(HALFWAY)]} { set mask(HALFWAY) "%sitein%c0 [b]HALFWAY%c1:[b]%c2 [b]%rel%c1[b] is in halfway. Leading uploader is%c2 [b]%user[b]%c1 /%c2 %group%c1 \[%c2[b]%mb[b]%c1 %c2[b]%files[b]%c1F %c2[b]%percent[b]%c1% %c2[b]%speed[b]%c1/s\] with%c2 [b]%leftfiles[b]%c1F left." }
        if {![info exists mask(STATS)]} { set mask(STATS) "%sitein%c2 %text" }
        if {![info exists mask(STATSUSER)]} { set mask(STATSUSER) "%sitein%c2 %place%c1.%c2 [b]%user[b]%c1 /%c2 %group%c1 \[%c2[b]%mb[b]%c1 %c2[b]%files[b]%c1F %c2[b]%percent[b]%c1% %c2[b]%speed[b]%c1/s\]." }
        if {![info exists mask(STATSGROUP)]} { set mask(STATSGROUP) "%sitein%c2 %place%c1.%c2 [b]%group[b]%c1 \[%c2[b]%mb[b]%c1 %c2[b]%files[b]%c1F %c2[b]%percent[b]%c1% %c2[b]%speed[b]%c1/s\]." }
        if {![info exists mask(REQUEST)]} { set mask(REQUEST) "%sitein%c0 [b]REQUEST%c1:%c2 %user[b]%c1 adds a request for%c2 [b]%rel[b]%c1. Please fill ASAP." }
        if {![info exists mask(REQFILLED)]} { set mask(REQFILLED) "%sitein%c0 [b]REQFiLLED%c1: %rel%c2[b]%c1 filled by%c2 [b]%user[b]%c1. Good work." }
        if {![info exists mask(SLAVEONLINE)]} { set mask(SLAVEONLINE) "%sitein%c0 [b]SLAVE %slave%c1:[b] Came online with%c2 [b]%freespace[b]%c1 /%c2 [b]%totalspace[b]%c1." }
        if {![info exists mask(SLAVEOFFLINE)]} { set mask(SLAVEOFFLINE) "%sitein%c0 [b]SLAVE %slave%c1:[b] Went offline: %msg" }
        if {![info exists mask(SHUTDOWN)]} { set mask(SHUTDOWN) "%sitein%c0 [b]SHUTDOWN%c1: %msg" }
        if {![info exists mask(WIPE)]} { set mask(WIPE) "%sitein%c0 [b]WiPE%c1:%c2 %user[b]%c1 /%c2 %group%c1 just wiped%c2 [b]%rel[b]%c1." }
      } { }
      if {![info exists sections]} { set sections "Svcd xXx"}
      if {![info exists chans(DEFAULT)]} { set chans(DEFAULT) "#xXx"}
      if {![info exists echovars(ONELINESTATS)]} { set echovars(ONELINESTATS) "pf type place user group mb files percent speed" }
      if {![info exists echovars(NUKE)]} { set echovars(NUKE) "pf" }
      if {![info exists echovars(UNNUKE)]} { set echovars(UNNUKE) "pf" }
      if {![info exists echovars(PRE)]} { set echovars(PRE) "pf group user dirsize files sfvdir" }
      if {![info exists echovars(NEWDIR)]} { set echovars(NEWDIR) "pf user group tagline" }
      if {![info exists echovars(DELDIR)]} { set echovars(DELDIR) "pf user group tagline" }
      if {![info exists mask(ONELINESTATS)]} { set mask(ONELINESTATS) "%c2 %place%c1.%c2 %user%c1 /%c2 %group%c1 \[%c2%mb%c1mB%c2 %files%c1F%c2 %percent%c1%%c2 %speed%c1kB/s\]" }
      if {![info exists mask(NUKE)]} { set mask(NUKE) "%sitein %c0%type %multx%c1:%c2 %dir%c1 was nuked by Nuker:%c2 %nuker%c1 Reason:%c2 %reason::%sitein%c0 [b]NUKEE(s)%c1:[b]%c2 %nukee" }
      if {![info exists mask(UNNUKE)]} { set mask(UNNUKE) "%sitein %c0%type %multx%c1:%c2 %dir%c1 was unuked by Nuker:%c2 %nuker%c1 Reason:%c2 %reason%c1::%sitein%c0 [b]NUKEE(s)%c1:[b]%c2 %nukee" }
      if {![info exists mask(PRE)]} { set mask(PRE) "%sitein%c0 [b]%path PRE%c1:[b]%c2 [b]%rel[b]%c1 at%c2 [b]%now[b]%c1 by%c2 [b]%user[b]%c1 /%c2 [b]%group[b]%c1 \[%c2[b]%dirsize%c1[b]M in%c2 [b]%files%c1[b]F%c2 [b]%sfvdir%c1[b]Dir(s)\]" }
      if {![info exists mask(NEWDIR)]} { set mask(NEWDIR) "%sitein%c0 [b]NEW RELEASE%c1:[b]%c2 -%path- [b]%rel[b] %c1at%c2 [b]%now[b]%c1 by%c2 [b]%user[b]%c1 /%c2 %group%c1. \[%c2%tagline%c1\]" }
      if {![info exists mask(DELDIR)]} { set mask(DELDIR) "%sitein%c0 [b]DELETED%c1:[b]%c2 -%path- [b]%rel[b]%c1 by%c2 [b]%user[b]%c1 /%c2 %group%c1." }
    }
  } { }
}

sitebot:main